/* This file is part of PHEX */

#ifndef _HEX_H_
#define _HEX_H_

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>

#define CURSOR_HEX	0
#define CURSOR_CHAR	1

#define CONTROL_CHAR	11	/* ^K */

typedef unsigned char byte;

int init_screen(void);
void show_top(int modified);
void update_screen(int x);
void move_cursor(off_t new);
void print_help(int x);

void goto_offset(void);
void main_loop(void);
void copy_block(off_t s, off_t e);
void on_sigint(int x);
void ask_for_exit(void);
void snr_txt(void);
off_t bfi_search(void);

byte *read_data(byte *name, off_t *sizebuf, byte *oldbuf, off_t max);
void save_file(void);
void save_block(int s, int e);
void insert_file(void);
void edit_file(void);
void snx(void);

void complain(int fatal, char *fmt, ...);
void print_status(char *txt);
int input_status(char *txt, char *buf, int len);
int ask_status(char *txt);
void clean_exit(void);

#endif /* _HEX_H_ */
